SystemOrganization addCategory: #Roulette!

TestCase subclass: #ResizedRoulettePrizeGamblingTest
	instanceVariableNames: 'roulette'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roulette'!

!ResizedRoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:05'!
setUp

	super setUp.
	
	roulette := Roulette new.
	roulette add: 'TV set' area: 20.
	roulette add: 'car' area: 10.
	roulette add: 'house' area: 5.
	roulette add: 'slippers' area: 70.
	roulette add: 'iphone' area: 30.
	
	roulette areaSum: 10.
	
! !

!ResizedRoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:08'!
testCar

	self assert: 'car' equals:   (roulette ball: 9).
	self assert: 'car' equals:   (roulette ball: 9.3).
	self assert: 'car' equals:   (roulette ball: 9.6).! !

!ResizedRoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:09'!
testHouse

	self assert: 'house' equals:   (roulette ball: 9.7).
	self assert: 'house' equals:   (roulette ball: 10).
! !

!ResizedRoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:10'!
testIPhone

	self assert: 'iphone' equals:   (roulette ball: 5.26).
	self assert: 'iphone' equals:   (roulette ball: 5.9).
	self assert: 'iphone' equals:   (roulette ball: 7.4).! !

!ResizedRoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:18'!
testOutSideLeft

	self should: [roulette ball: -1]  raise: Error.
	! !

!ResizedRoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:18'!
testOutSideRight

	self should: [roulette ball: 11]  raise: Error.
	! !

!ResizedRoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:11'!
testSlippers

	self assert: 'slippers' equals:   (roulette ball: 0).
	self assert: 'slippers' equals:   (roulette ball: 0.3).
	self assert: 'slippers' equals:   (roulette ball: 1).
	self assert: 'slippers' equals:   (roulette ball: 2).
	self assert: 'slippers' equals:   (roulette ball: 3).
	self assert: 'slippers' equals:   (roulette ball: 4).
	self assert: 'slippers' equals:   (roulette ball: 5.11).! !

!ResizedRoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:12'!
testTvSet

	self assert: 'TV set' equals:   (roulette ball: 7.5).
	self assert: 'TV set' equals:   (roulette ball: 8.0).
	self assert: 'TV set' equals:   (roulette ball: 8.8).
! !

TestCase subclass: #RoulettePrizeGamblingTest
	instanceVariableNames: 'roulette'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roulette'!

!RoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 19:56'!
setUp

	super setUp.
	
	roulette := Roulette new.
	roulette add: 'TV set' area: 20.
	roulette add: 'car' area: 10.
	roulette add: 'house' area: 5.
	roulette add: 'slippers' area: 70.
	roulette add: 'iphone' area: 30.
	
! !

!RoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:02'!
testCar

	self assert: 'car' equals:   (roulette ball: 121).
	self assert: 'car' equals:   (roulette ball: 125).
	self assert: 'car' equals:   (roulette ball: 130).! !

!RoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:03'!
testHouse

	self assert: 'house' equals:   (roulette ball: 131).
	self assert: 'house' equals:   (roulette ball: 135).
! !

!RoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:00'!
testIPhone

	self assert: 'iphone' equals:   (roulette ball: 71).
	self assert: 'iphone' equals:   (roulette ball: 80).
	self assert: 'iphone' equals:   (roulette ball: 100).! !

!RoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:18'!
testOutSideLeft

	self should: [roulette ball: -1]  raise: Error.
	! !

!RoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:18'!
testOutSideRight

	self should: [roulette ball: 136]  raise: Error.
	! !

!RoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 19:43'!
testSlippers

	self assert: 'slippers' equals:   (roulette ball: 0).
	self assert: 'slippers' equals:   (roulette ball: 4).
	self assert: 'slippers' equals:   (roulette ball: 20).
	self assert: 'slippers' equals:   (roulette ball: 30).
	self assert: 'slippers' equals:   (roulette ball: 60).
	self assert: 'slippers' equals:   (roulette ball: 65).
	self assert: 'slippers' equals:   (roulette ball: 69).! !

!RoulettePrizeGamblingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:01'!
testTvSet

	self assert: 'TV set' equals:   (roulette ball: 101).
	self assert: 'TV set' equals:   (roulette ball: 119).
	self assert: 'TV set' equals:   (roulette ball: 120).
! !

Object subclass: #Roulette
	instanceVariableNames: 'slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roulette'!

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 18:54'!
add: anObject area: aNumber

	self slots add: (RouletteSlot area: aNumber subject: anObject)! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
areaSum

	^(slots collect: [:slot|slot area]) sum! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
areaSum: aNumber

	|scale|
	scale :=  aNumber / self areaSum.
	slots do: [:slot| slot area: slot area * scale]! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 7/2/2011 20:17'!
ball: aNumber
	
	aNumber < 0 ifTrue: [ self error: 'cannot be negative' ].
	^(self ballAndLocalBall: aNumber) first! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:04'!
ballAndLocalBall: aNumber

	|searchKey|
	searchKey := aNumber.
	slots do: [:slot| searchKey <= slot area ifTrue: [^Array with: slot subject with: searchKey] ifFalse: [searchKey := searchKey - slot area]].
	self error: 'Wide off the board'! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:05'!
localBall: aNumber

	^(self ballAndLocalBall: aNumber) second! !

!Roulette methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 19:06'!
remove: anObject

	slots remove: (slots detect: [:sl| sl subject == anObject])! !

!Roulette methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:02'!
slots
	
	slots isNil ifTrue: [ 
		self slots: (SortedCollection sortBlock: #area descendingSortBlock)
	].
	^slots! !

!Roulette methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:03'!
slots: aSortedCollection
	
	slots := aSortedCollection! !

Object subclass: #RouletteSlot
	instanceVariableNames: 'area subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roulette'!

!RouletteSlot classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/2/2008 18:58'!
area: aNumber subject: anObject

	^self new area: aNumber; subject: anObject! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:03'!
area
	^area! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 18:59'!
area: aNumber

	area := aNumber! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 19:04'!
subject

	^subject! !

!RouletteSlot methodsFor: 'accessing' stamp: 'hjo 6/2/2008 18:59'!
subject: anObject

	subject := anObject! !
